#!/usr/bin/perl
# Copyright: Binny V Abraham 2003-2004                                       #
# If you want to use this script, Leave this message here                    #
##############################################################################
# Website: http://binnyva.tripod.com                                         #
# E-Mail : binnyva@rediffmail.com                                            #
# Get more Perl scripts from http://binnyva.tripod.com/code/perl             #
##############################################################################
# Name : LineRename                                                          #
# Version : 1.00.A                                                           #
# From November 05, 2003 to November 06, 2003                                #
#                                                                            #
# Renames all the txt files in a folder to their respective first lines.     #
# If there are blank lines, it clears the file of all blank lines.           #
##############################################################################


#Takes the directory in the command line
if($ARGV[0])
 {
 $docroot = $ARGV[0];
 print "Search in @ARGV[0]\n";
 }
else 
 {
 print "Plese specify the directory...\n";
 exit 0;
 }

#Changes to the specifed directory
chdir($docroot);

# Get a list of all matching files
my $list;
$list = `dir /b *.txt`;

my @LIST = split(/\s+/, $list);

print "----------------------------------------------------------\n";
print "Files to Process\n";
print "----------------------------------------------------------\n";

$have_problem = 0;

foreach $file (@LIST) 
 {
 open (FILE, "$file") || die "Can't open $file: $!\n";
 @LINES=<FILE>;
 close(FILE);
 $SIZE=@LINES;

 $_ = $LINES[0];
 unless (/^( )*$/) #Get the first lines which are not empty or has only spaces.
  {
  $data=$_;
  chop($data); #Delete the \n at the end of the line
  $data =~ s/\,$//gi;
  $data =~ s/\.$//gi;
  $data =~ s/\?$//gi;
  $data =~ s/\;$//gi; #Delete the last charector if it is punctuation.
  
  $name = $data . ".txt"; #Gives the first line an extension '.txt'
    
  if(rename($file, $name)) #Renames the file in format <1stLine>.txt
   {
   print "'$file' -> '$name'\n";
   }
  else
   {
   print "Can't rename '$file' to '$name' because $!";
   }
  }
 else #If the first line is empty, put the file in the problem list.
  {
  print "Problem in $file\n";  
  $probs[++$#probs] = $file;
  $have_problem=1;
  }
 }

print "\n--------------------\nAll the problems...\n---------------------\n";
# To clear out all the empty lines in the file.
if($have_problem)
 {
 foreach $problem (@probs)
  {
  $out = "";
  print "\nProblem = $problem";
  
  open(FILEIN,"$problem") || die "Can't open $problem because $!\n";
  @LINES=<FILEIN>;
  close(FILEIN);
  $SIZE=@LINES;

  for($i=0;$i<$SIZE;$i++)
   {
   $_=$LINES[$i]; #Get the lines
   unless (/^( )*$/) #Filter out the empty lines and save the none empty ones
    {
    $out = $out . $_;
    }
   }
  #Write the non-empty lines to the file
  open (OUTFILE,">$problem") || die "Can't open file $res_file for editing because $!\n";
  print OUTFILE "$out";
  close(OUTFILE);
  }
 }
print "\n";


########################################################################
#TO DO
#--------
#Two files with same first line gives same file name
#Filename unsupported charecters in first line. Eg. / \ * " < > : ? |
#Duplicate files
#Totally blank files
#Big First lines